diff -Nur linux-2.4.30/drivers/sound/au1550_i2s_hw.c linux-2.4.30-linux-mips.org/drivers/sound/au1550_i2s_hw.c
--- linux-2.4.30/drivers/sound/au1550_i2s_hw.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/sound/au1550_i2s_hw.c	2005-05-12 18:01:29.000000000 +0200
@@ -0,0 +1,664 @@
+/*
+ *      au1550_i2s_hw.c  --  Sound driver support for AMD Alchemy 
+ *   			Au1550/Au1200 MIPS Processor Cores
+ *
+ * The WM8731 CODEC only has one input for ADC recording device. Below
+ * is a snipet of code that illustrates how to swtich between MIC and
+ * LINE for WM8731. This can be used for other CODECs as long as the
+ * set_recsrc() routine is implemented properly.
+ *
+		#include <unistd.h>
+		#include <stdlib.h>
+		#include <stdio.h>
+		#include <fcntl.h>
+		#include <sys/soundcard.h>
+		#include <sys/ioctl.h>
+
+		int main (int argc, char **argv)
+		{
+			char *mixer="/dev/mixer";
+			int fpmixer, insel=SOUND_MASK_LINE;
+			int val;
+
+			fpmixer = open(mixer, O_RDWR );
+			if (-1 == fpmixer) {
+				return -1;
+			}
+			if ( argc > 1 ) insel = SOUND_MASK_MIC;
+			ioctl(fpmixer, SOUND_MIXER_WRITE_RECSRC, &insel);
+			return 0;
+		}
+*/
+
+
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/kernel.h>
+#include <linux/ioport.h>
+#include <linux/sound.h>
+#include <linux/slab.h>
+#include <linux/soundcard.h>
+#include <linux/string.h>
+#include <linux/errno.h>
+#include <linux/bitops.h>
+#include <linux/delay.h>
+#include <asm/io.h>
+#include <asm/uaccess.h>
+#include <asm/hardirq.h>
+#include <asm/au1000.h>
+
+#include <asm/au1xxx_psc.h>
+
+#include "au1550_i2s.h"
+
+
+#if !defined(CONFIG_I2C_ALGO_AU1550)
+	#error 
+	#error 
+	#error I2C Support is required for I2S Codec configuration. \
+	Please enable Au1xxx I2C support and rebuild.
+	#error 
+	#error 
+#endif
+
+static void
+au1550_delay(int msec)
+{
+	unsigned long   tmo;
+	signed long     tmo2;
+
+	if (in_interrupt())
+		return;
+
+	tmo = jiffies + (msec * HZ) / 1000;
+	for (;;) {
+		tmo2 = tmo - jiffies;
+		if (tmo2 <= 0)
+			break;
+		schedule_timeout(tmo2);
+	}
+}
+
+#if defined(WM8731) || defined(WM8721)
+
+#define WM_VOLUME_MIN	47
+#define WM_VOLUME_SCALE	80
+
+volatile static struct i2s_ro_mixer {
+	unsigned int value;
+	unsigned int scale;
+	unsigned int hw_min;
+} i2s_ro_mixer[SOUND_MIXER_NRDEVICES]= {
+	[SOUND_MIXER_PCM]	=	{0x5050,79,0x30},
+#if defined(WM8731)
+	[SOUND_MIXER_LINE]	=	{0x4343,31,0},
+	[SOUND_MIXER_MIC]	=	{0x4343,31,0},
+#endif
+};
+
+#define WM_SC_SR_96000		(0x7<<2)
+#define WM_SC_SR_88200		(0xF<<2)
+#define WM_SC_SR_48000		(0x0<<2)
+#define WM_SC_SR_44100		(0x8<<2)
+#define WM_SC_SR_32000		(0x6<<2)
+#define WM_SC_SR_8018		(0x9<<2)
+#define WM_SC_SR_8000		(0x1<<2)
+#define WM_SC_MODE_USB		1
+#define WM_SC_MODE_NORMAL	0
+#define WM_SC_BOSR_250FS	(0<<1)
+#define WM_SC_BOSR_272FS	(1<<1)
+#define WM_SC_BOSR_256FS	(0<<1)
+#define WM_SC_BOSR_128FS	(0<<1)
+#define WM_SC_BOSR_384FS	(1<<1)
+#define WM_SC_BOSR_192FS	(1<<1)
+
+enum wolfson_registers {
+	L_LINE_IN=0,
+	R_LINE_IN,
+	L_HEADPHONE_OUT,			
+	R_HEADPHONE_OUT,			
+	ANALOGUE_AUDIO_PATH_CTRL,
+	DIGITAL_AUDIO_PATH_CTRL,	
+	POWER_DOWN_CTRL,
+	DIGITAL_AUDIO_IF,			
+	SAMPLING_CONTROL, 		
+	ACTIVE_CTRL,
+	RESET=0xF };
+
+static void wm87x1_wrcodec(u8 ctlreg, u16 val)
+{
+	int	rcnt;
+	
+	extern int pb1550_wm_codec_write(u8 addr, u8 reg, u8 val);
+	/* The codec is a write only device, with a 16-bit control/data
+	 * word.  Although it is written as two bytes on the I2C, the
+	 * format is actually 7 bits of register and 9 bits of data.
+	 * The ls bit of the first byte is the ms bit of the data.
+	 */
+	rcnt = 0;
+	while ((pb1550_wm_codec_write((0x36 >> 1), 
+					(ctlreg << 1) | ((val >> 8) & 0x01), 
+					(u8) (val & 0x00FF)) != 1) && 
+			(rcnt < 50)) {
+		rcnt++;
+	}
+	if ( rcnt >= 50 ) printk("timeout wm87x1_wrcodec: reg:%x val:%x\n", ctlreg, val);
+
+	au1550_delay(10);
+}
+
+
+static void wm87x1_set_recsrc(struct i2s_hw *hw, int src)
+{
+	u16 val=0;
+	hw->wrcodec(ACTIVE_CTRL, 0x00);	 	/* Deactivate codec */
+
+#if defined(WM8731)
+	/* if its not MIC, then it must be LINEIN. The check for available mask
+	   should ahve been done at the ioctl level
+	 */
+	if ( src & SOUND_MASK_MIC )	
+		val = 5; 
+	hw->wrcodec(ANALOGUE_AUDIO_PATH_CTRL, 0x18 | val);	/* DAC sel, BYPASS and INSEL(val) */
+#endif
+
+	hw->wrcodec(ACTIVE_CTRL, 0x01);	 	/* Activate codec */
+}
+
+static int wm87x1_read_mixer(struct i2s_hw *hw, u16 oss_channel)
+{
+    int left, right;
+/*	int scale = i2s_ro_mixer[oss_channel].scale; */
+
+	left = (i2s_ro_mixer[oss_channel].value>>8)&0x7f;
+	right = (i2s_ro_mixer[oss_channel].value)&0x7f;
+
+	return (left | (right << 8));
+}
+
+static void wm87x1_write_mixer(struct i2s_hw *hw, u16 oss_channel, u16 val)
+{
+	int scale = i2s_ro_mixer[oss_channel].scale;
+	unsigned int left,right;
+
+	/* cleanse input a little */
+	right = ((val >> 8)  & 0xff) ;
+	left = (val  & 0xff) ;
+
+	if (right > 100) right = 100;
+	if (left > 100) left = 100;
+
+	i2s_ro_mixer[oss_channel].value = left<<8 | right;
+
+	right = (right * scale) / 100;
+	left = (left * scale) / 100;
+
+	right += i2s_ro_mixer[oss_channel].hw_min;
+	left  += i2s_ro_mixer[oss_channel].hw_min;
+
+	printk("write_mixer, chan:%d val:%d\n", oss_channel, val);
+	switch( oss_channel ) {
+	case SOUND_MIXER_PCM:
+		hw->wrcodec(L_HEADPHONE_OUT, left);
+		hw->wrcodec(R_HEADPHONE_OUT, right);
+		break;
+	case SOUND_MIXER_LINE:
+		hw->wrcodec(L_LINE_IN, left);
+		hw->wrcodec(R_LINE_IN, right);
+		break;
+	}
+}
+
+#endif
+
+#if defined(WM8731) || defined(WM8721)
+static void wm87x1_codec_init(struct i2s_hw *hw)
+{
+	hw->wrcodec(RESET, 0x00);				/* Reset */
+	hw->wrcodec(POWER_DOWN_CTRL, 0x00); 	/* Power up everything */
+	hw->wrcodec(ACTIVE_CTRL, 0x00);	 	/* Deactivate codec */
+
+	/* 
+	 *	Setup some default mixer settings :)
+	 */
+	hw->set_mixer(hw, SOUND_MIXER_PCM, (54<<8)|54);
+#if !defined(WM8721)
+	hw->set_mixer(hw, SOUND_MIXER_MIC, (74<<8)|74);
+	hw->set_mixer(hw, SOUND_MIXER_LINE, (74<<8)|74);
+
+	hw->wrcodec(ANALOGUE_AUDIO_PATH_CTRL, 0x18);	/* DAC sel, BYPASS and LINEIN */
+#else
+	hw->wrcodec(ANALOGUE_AUDIO_PATH_CTRL, 0x10);	/* DAC sel */
+#endif
+
+	hw->wrcodec(DIGITAL_AUDIO_PATH_CTRL, 0x00);	/* Disable output mute */
+
+	/* Set slave/master mode in codec */
+	if(hw->codec_is_master)
+		hw->wrcodec(DIGITAL_AUDIO_IF, 0x42);/* Set MASTER, 16-bit, I2S modes */
+	else
+		hw->wrcodec(DIGITAL_AUDIO_IF, 0x02);/* Set SLAVE,  16-bit, I2S modes */
+	
+	hw->wrcodec(SAMPLING_CONTROL, 0x23);	/* Default SR */
+	hw->wrcodec(ACTIVE_CTRL, 0x01);	 	/* Activate codec */
+}
+#endif
+
+#if defined(WM8731)
+
+/*
+ *	The WM8731 I2S Codec cannot use completly different sample
+ *	rate for ADC and DAC. There is small table in a Wolfson
+ *  whitepaper "Master clocks and audio sample rates supported
+ *  by Wolfson's Portable Audio IC's". 
+ * 
+ *  ASSUMES 12MHZ and USB mode settings for CODEC!!
+ *  ASSUMES 12MHZ and USB mode settings for CODEC!!
+ *
+ *  The function below implements the combinations specified in 
+ *  the whitepaper.
+ *
+ */
+static int
+wm8731_set_rates( struct i2s_hw *hw, unsigned int *in, unsigned int *out )
+{
+	volatile psc_i2s_t* ip = (volatile psc_i2s_t *)I2S_PSC_BASE;
+	u32 cfg=0;
+	u16 codec_cfg=0;
+	unsigned int adc=*in, dac=*out;
+  
+    /* Deactivate codec */
+	hw->wrcodec(ACTIVE_CTRL, 0x00);	/* Deactivate codec */
+
+	/*
+	 *	If the PSC is master, then we need to disable PSC before
+	 *  updating registers.
+	 */
+	if ( !(hw->codec_is_master) )	{
+		/* Disable I2S controller */
+		ip->psc_i2scfg &= ~PSC_I2SCFG_DE_ENABLE;
+		au_sync();
+		/* Wait for device disabled */
+		while ((ip->psc_i2sstat & PSC_I2SSTAT_DR) == 1);
+		cfg = ip->psc_i2scfg;
+		/* Clear WS and DIVIDER values */
+		cfg &= ~(PSC_I2SCFG_WS_MASK | PSC_I2SCFG_DIV_MASK);	
+	}
+
+	if ( adc == 8000 && dac == 8000 ) { 
+		// for 8000 USB=1 BOSR=1 fs=1500
+		cfg |= PSC_I2SCFG_SET_WS(94);
+		cfg |= PSC_I2SCFG_DIV16;
+		codec_cfg = (0x03<<2) | WM_SC_MODE_USB;
+	}
+	/* We cannot get 11025 with codec as master --- that I know of */
+	else if ( !hw->codec_is_master && adc == 11025 && dac == 11025 ) { 
+		// for 11025 USB=1 BOSR=1 fs=272
+		cfg |= PSC_I2SCFG_SET_WS(68);
+		cfg |= PSC_I2SCFG_DIV16;
+		codec_cfg = WM_SC_SR_44100 | WM_SC_BOSR_272FS | WM_SC_MODE_USB;
+	}
+	/* We cannot get 22050 with codec as master --- that I know of */
+	else if ( !hw->codec_is_master && adc == 22050 && dac == 22050 ) { 
+		// for 22050 USB=1 BOSR=1 fs=544.22
+		cfg |= PSC_I2SCFG_SET_WS(68);
+		cfg |= PSC_I2SCFG_DIV8;
+        codec_cfg = WM_SC_SR_44100 | WM_SC_BOSR_272FS | WM_SC_MODE_USB;
+	}
+	else if ( adc == 32000 && dac == 32000 ) { 
+		// for 32000 USB=1 BOSR=1 fs=375
+		cfg |= PSC_I2SCFG_SET_WS(94);
+		cfg |= PSC_I2SCFG_DIV4;
+		codec_cfg = WM_SC_SR_32000 | WM_SC_BOSR_272FS | WM_SC_MODE_USB;
+	}
+	else if ( adc == 44100 && dac == 44100 ) { 
+		// for 44100 USB=1 BOSR=1 fs=272
+		cfg |= PSC_I2SCFG_SET_WS(68);
+		cfg |= PSC_I2SCFG_DIV4;
+		codec_cfg = WM_SC_SR_44100 | WM_SC_BOSR_272FS | WM_SC_MODE_USB;
+	}
+	else if ( adc == 48000 && dac == 48000 ) { 
+		// for 48 USB=1 BOSR=0 fs=250
+		cfg |= PSC_I2SCFG_SET_WS(125);
+		cfg |= PSC_I2SCFG_DIV2;
+		codec_cfg = WM_SC_SR_48000 | WM_SC_MODE_USB;
+	}
+	else if ( adc == 88200 && dac == 88200 ) { 
+		// for 88200 USB=1 BOSR=1 fs=136
+		cfg |= PSC_I2SCFG_SET_WS(68);
+		cfg |= PSC_I2SCFG_DIV2;
+		codec_cfg = WM_SC_SR_88200 | WM_SC_BOSR_272FS | WM_SC_MODE_USB;
+	}
+	else if ( adc == 96000 && dac == 96000 ) { 
+		// for 96000 USB=1 BOSR=0 fs=125
+		cfg |= PSC_I2SCFG_SET_WS(63);
+		cfg |= PSC_I2SCFG_DIV2;
+		codec_cfg = WM_SC_SR_96000 | WM_SC_MODE_USB;
+	}
+	/*
+	 *	This is the default sample rate for this platform. 
+	 *  There is a little bit of code duplication here.... but wanted to
+	 *  make it easy to replace defaults. Im sure there is a better way
+	 *  but I'm in a hurry :)
+	 */
+	else  {
+		// for 48 USB=1 BOSR=0 fs=250
+		cfg |= PSC_I2SCFG_SET_WS(125);
+		cfg |= PSC_I2SCFG_DIV2;
+		codec_cfg = WM_SC_SR_48000 | WM_SC_MODE_USB;
+		hw->sr = adc = dac = 48000;
+	}
+
+	if (!(hw->codec_is_master)){
+		/* Reconfigure and enable */
+		ip->psc_i2scfg = cfg;
+		au_sync();
+		ip->psc_i2scfg = cfg  | PSC_I2SCFG_DE_ENABLE;
+		au_sync();
+		/* Wait for device enabled */
+		while ((ip->psc_i2sstat & PSC_I2SSTAT_DR) == 0);
+	}
+
+	hw->wrcodec(SAMPLING_CONTROL, codec_cfg);
+
+	/* Activate codec */
+	hw->wrcodec(ACTIVE_CTRL, 0x01);
+
+	*in = adc;
+	*out = dac;
+	return 0;
+}
+#endif
+
+#if defined(WM8721)
+/*
+ *	The WM8721 I2S Codec does not support ADC.
+ * 
+ *	*** ASSUMES we are operating in NORMAL -- variable clocks
+ *      ASSUMES CODEC is always the master
+ *
+ */
+static int 
+wm8721_set_rates( struct i2s_hw *hw, unsigned int *in, unsigned int *out )
+{
+	u16 codec_cfg=0;
+	unsigned int dac=*out;
+
+#if defined(CONFIG_MIPS_FICMMP)
+	ficmmp_set_i2s_sample_rate(dac);
+#endif
+
+    /* Deactivate codec */
+	hw->wrcodec(ACTIVE_CTRL, 0x00);	/* Deactivate codec */
+
+	switch( dac ) {
+		case 8000:
+			codec_cfg = WM_SC_SR_8000;
+			break;
+		case 8018:			
+			codec_cfg = WM_SC_SR_8018;
+			break;
+		case 32000:
+			codec_cfg = WM_SC_SR_32000;
+			break;
+		case 44100:
+			codec_cfg = WM_SC_SR_44100;
+			break;
+		case 48000:
+			codec_cfg = WM_SC_SR_48000;
+			break;
+		case 88200:
+			codec_cfg = WM_SC_SR_88200;
+			break;
+		case 96000:
+			codec_cfg = WM_SC_SR_96000;
+			break;
+
+	}
+	hw->wrcodec(SAMPLING_CONTROL, codec_cfg);
+
+	/* Activate codec */
+	hw->wrcodec(ACTIVE_CTRL, 0x01);
+
+	*in = 0;
+	*out = dac;
+	return 0;
+}
+#endif
+
+
+
+/*
+ *	The meat of the HW init.
+ */
+#if defined(CONFIG_MIPS_PB1200) || defined(CONFIG_MIPS_DB1200) \
+    || defined(CONFIG_MIPS_PB1550) || defined(CONFIG_MIPS_DB1550)
+
+static struct i2s_hw _i2s =	{ 
+	.name 			= "Wolfson WM8731 i2s", 
+	.input_mask 	= SOUND_MASK_LINE | SOUND_MASK_MIC,
+	.output_mask	= SOUND_MASK_PCM,
+	.codec_init		= wm87x1_codec_init, 
+	.wrcodec		= wm87x1_wrcodec, 
+	.set_rates		= wm8731_set_rates, 
+	.get_mixer		= wm87x1_read_mixer, 
+	.set_mixer		= wm87x1_write_mixer,
+	.set_recsrc		= wm87x1_set_recsrc };
+
+static struct i2s_hw * AMD_PbDb_setup(u32 psc, u32 clock) 
+{
+	volatile psc_i2s_t *ip = (volatile psc_i2s_t *)psc;
+	u32 div, clk,val;
+	struct i2s_hw *i2s=&_i2s;
+
+	i2s->psc = ip;
+	ip->psc_ctrl = PSC_CTRL_DISABLE;	/* Disable PSC */
+	au_sync();
+	
+#if defined(CONFIG_MIPS_PB1200) || defined(CONFIG_MIPS_DB1200)
+	/* CPLD Mux for I2s */
+	bcsr->resets |= BCSR_RESETS_PCS1MUX;
+	au_sync();
+#endif
+
+	/*
+	  	Clocking for a PSC in I2S mode can be complicated due to the
+	    numerous schemes available.
+	 
+	    The Pb/Db1200 and Pb/Db1550 have a 12Mhz clock off the codec
+	    with the codec outputing the clock on CLK_OUT pin. THe PSC uses
+		this clock as its internal clock.
+
+		Pb1200 Option :
+		Another option would be to disconnect the 12Mhz clock,X4, hanging
+		off the Wolfson CODEC and populate resistors R153 and R155
+		and unpopulate R167.
+		The PSC would need to be configured to output its clock on GPIO2.
+		Please refer to the databook for more detailed information.
+		The resistor locations are different on the Pb/Db1550 but the
+		same concept applies.
+	 */
+	switch (clock)	{
+		case PSC_SEL_CLK_INTCLK:
+			i2s->codec_is_master = 0;
+
+			/* The FRDIV in the frequency control is (FRDIV + 1) * 2
+			   Our goal is to have intclk==12MHz
+			*/
+			clk = au_readl(SYS_FREQCTRL1);
+			div = au_readl(SYS_AUXPLL);
+			au_sync();
+			clk &= ~(SYS_FC_FRDIV4_MASK | SYS_FC_FS4);;
+			clk |= (div << SYS_FC_FRDIV4_BIT);
+			clk |= SYS_FC_FE4;
+			au_writel(clk, SYS_FREQCTRL1);
+			au_sync();
+
+			/* Set up the clock source routing to get Freq4 to PSC1_intclk.
+			*/
+			clk = au_readl(SYS_CLKSRC);
+			au_sync();
+			clk &= ~0x3e000000;
+			clk |= (6 << 27); /* 6 == Freq4, refer to databook pg 451 */
+			au_writel(clk, SYS_CLKSRC);
+			au_sync();
+			break;
+
+		case PSC_SEL_CLK_EXTCLK:
+			i2s->codec_is_master = 0;
+			break;
+
+		case PSC_SEL_CLK_SERCLK:
+			i2s->codec_is_master = 1;
+			break;
+
+		default:
+			i2s->codec_is_master = 1;
+			clock = PSC_SEL_CLK_SERCLK;
+			break;
+
+	}
+
+	/* Codec must be initialized here, after codec_is_master is determined. */
+	i2s->codec_init(i2s);
+
+	ip->psc_sel = (clock | PSC_SEL_PS_I2SMODE);
+	au_sync();
+
+	/* Enable PSC
+	*/
+	ip->psc_ctrl = PSC_CTRL_ENABLE;
+	au_sync();
+
+	/* Wait for PSC ready.
+	*/
+	do {
+		val = ip->psc_i2sstat;
+		au_sync();
+	} while ((val & PSC_I2SSTAT_SR) == 0);
+
+	/* Configure I2S controller.
+	 * Deep FIFO, 16-bit sample, DMA, make sure DMA matches fifo size.
+	 * Actual I2S mode (first bit delayed by one clock).
+	 */
+	val = PSC_I2SCFG_SET_LEN(16) | 
+          PSC_I2SCFG_RT_FIFO8 | 
+		  PSC_I2SCFG_TT_FIFO8 |
+		  PSC_I2SCFG_BI | 
+		  PSC_I2SCFG_XM;
+
+	if (i2s->codec_is_master) val |= PSC_I2SCFG_MS;
+
+	ip->psc_i2scfg = val | PSC_I2SCFG_DE_ENABLE;
+	au_sync();
+
+	/* Wait for device enabled */
+	while ((ip->psc_i2sstat & PSC_I2SSTAT_DR) == 0);
+	return i2s;
+}
+#endif
+
+
+/*
+ *	The meat of the HW init.
+ */
+#if defined(CONFIG_MIPS_FICMMP)
+
+static struct i2s_hw _i2s =	{ 
+	.name 			= "Wolfson WM8721 i2s", 
+	.input_mask 	= 0,
+	.output_mask	= SOUND_MASK_PCM,
+	.codec_init		= wm87x1_codec_init,
+	.wrcodec		= wm87x1_wrcodec,
+	.set_rates		= wm8721_set_rates,
+	.get_mixer		= wm87x1_read_mixer,
+	.set_mixer		= wm87x1_write_mixer,
+	.set_recsrc		= wm87x1_set_recsrc };
+
+static struct i2s_hw * ficmmp_setup(u32 psc, u32 clock) 
+{
+	volatile psc_i2s_t *ip = (volatile psc_i2s_t *)psc;
+	struct i2s_hw *i2s=&_i2s;
+	u32 val;
+
+	i2s->psc = ip;
+	ip->psc_ctrl = PSC_CTRL_DISABLE;	/* Disable PSC */
+	au_sync();
+	
+
+	/*
+	  	Clocking for a PSC in I2S mode can be complicated due to the
+	    numerous schemes available.
+
+		We are going to always use SERCLK with PSC in slave mode.
+	 */
+	i2s->codec_is_master = 1;
+	clock = PSC_SEL_CLK_SERCLK;
+
+	/* Codec must be initialized here, after codec_is_master is determined. */
+	i2s->codec_init(i2s);
+
+	ip->psc_sel = (clock | PSC_SEL_PS_I2SMODE);
+	au_sync();
+
+	/* Enable PSC
+	*/
+	ip->psc_ctrl = PSC_CTRL_ENABLE;
+	au_sync();
+
+	/* Wait for PSC ready.
+	*/
+	do {
+		val = ip->psc_i2sstat;
+		au_sync();
+	} while ((val & PSC_I2SSTAT_SR) == 0);
+
+	/* Configure I2S controller.
+	 * Deep FIFO, 16-bit sample, DMA, make sure DMA matches fifo size.
+	 * Actual I2S mode (first bit delayed by one clock).
+	 */
+	val = PSC_I2SCFG_SET_LEN(16) | 
+          PSC_I2SCFG_RT_FIFO8 | 
+		  PSC_I2SCFG_TT_FIFO8 |
+		  PSC_I2SCFG_BI | 
+		  PSC_I2SCFG_XM;
+
+	if (i2s->codec_is_master) val |= PSC_I2SCFG_MS;
+
+	ip->psc_i2scfg = val | PSC_I2SCFG_DE_ENABLE;
+	au_sync();
+
+	/* Wait for device enabled */
+	while ((ip->psc_i2sstat & PSC_I2SSTAT_DR) == 0);
+	return i2s;
+}
+#endif
+
+struct i2s_hw * i2s_hw_init(void)
+{
+	/*
+	 *	Already initialized?
+	 */
+	if (!request_region(PHYSADDR(I2S_PSC_BASE),
+			    0x30, AU1XXX_MODULE_NAME)) {
+		err("I2S Audio ports in use");
+		return NULL;
+	}
+
+#if defined(CONFIG_MIPS_PB1200) || defined(CONFIG_MIPS_DB1200) \
+    || defined(CONFIG_MIPS_PB1550) || defined(CONFIG_MIPS_DB1550)
+	/* The header file defines the I2S_PSC_BASE 
+	   Run the PSC in Slave Mode 
+	 */
+	return(AMD_PbDb_setup(I2S_PSC_BASE, PSC_SEL_CLK_SERCLK));
+#endif
+
+#if defined(CONFIG_MIPS_FICMMP)
+	return(ficmmp_setup(I2S_PSC_BASE, PSC_SEL_CLK_SERCLK));
+#endif
+}
+
+void i2s_hw_cleanup(struct i2s_hw *hw)
+{
+	release_region(PHYSADDR(I2S_PSC_BASE), 0x30);
+}
diff -Nur linux-2.4.30/drivers/sound/au1550_psc.c linux-2.4.30-linux-mips.org/drivers/sound/au1550_psc.c
--- linux-2.4.30/drivers/sound/au1550_psc.c	2005-01-19 15:10:04.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/sound/au1550_psc.c	2005-05-12 17:57:32.000000000 +0200
@@ -30,6 +30,7 @@
  *  675 Mass Ave, Cambridge, MA 02139, USA.
  *
  */
+
 #include <linux/version.h>
 #include <linux/module.h>
 #include <linux/string.h>
@@ -63,6 +64,14 @@
 #include <asm/db1x00.h>
 #endif
 
+#ifdef CONFIG_MIPS_PB1200
+#include <asm/pb1200.h>
+#endif
+
+#ifdef CONFIG_MIPS_DB1200
+#include <asm/db1200.h>
+#endif
+
 #undef OSS_DOCUMENTED_MIXER_SEMANTICS
 
 #define AU1550_MODULE_NAME "Au1550 psc audio"
@@ -521,7 +530,14 @@
 	spin_unlock_irqrestore(&s->lock, flags);
 }
 
-
+/* 
+   NOTE: The xmit slots cannot be changed on the fly when in full-duplex 
+   because the AC'97 block must be stopped/started.  When using this driver 
+   in full-duplex (in & out at the same time), the DMA engine will stop if 
+   you disable the block.
+   TODO: change implementation to properly restart adc/dac after setting 
+   xmit slots.
+*/
 static void
 set_xmit_slots(int num_channels)
 {
@@ -565,6 +581,14 @@
 	} while ((stat & PSC_AC97STAT_DR) == 0);
 }
 
+/* 
+   NOTE: The recv slots cannot be changed on the fly when in full-duplex 
+   because the AC'97 block must be stopped/started.  When using this driver 
+   in full-duplex (in & out at the same time), the DMA engine will stop if 
+   you disable the block.
+   TODO: change implementation to properly restart adc/dac after setting 
+   recv slots.
+*/
 static void
 set_recv_slots(int num_channels)
 {
@@ -608,7 +632,6 @@
 
 	spin_lock_irqsave(&s->lock, flags);
 
-	set_xmit_slots(db->num_channels);
 	au_writel(PSC_AC97PCR_TC, PSC_AC97PCR);
 	au_sync();
 	au_writel(PSC_AC97PCR_TS, PSC_AC97PCR);
@@ -640,7 +663,6 @@
 			db->nextIn -= db->dmasize;
 	}
 
-	set_recv_slots(db->num_channels);
 	au1xxx_dbdma_start(db->dmanr);
 	au_writel(PSC_AC97PCR_RC, PSC_AC97PCR);
 	au_sync();
@@ -752,12 +774,16 @@
 	if (ac97c_stat & (AC97C_XU | AC97C_XO | AC97C_TE))
 		dbg("AC97C status = 0x%08x", ac97c_stat);
 #endif
+	/* There is a possiblity that we are getting 1 interrupt for
+	   multiple descriptors. Use ddma api to find out how many
+	   completed.
+	*/
 	db->dma_qcount--;
 
 	if (db->count >= db->fragsize) {
 		if (au1xxx_dbdma_put_source(db->dmanr, db->nextOut,
 							db->fragsize) == 0) {
-			err("qcount < 2 and no ring room!");
+			err("qcount < 2 and no ring room1!");
 		}
 		db->nextOut += db->fragsize;
 		if (db->nextOut >= db->rawbuf + db->dmasize)
@@ -941,11 +967,12 @@
 
 		/* duplicate every audio frame src_factor times
 		*/
-		for (i = 0; i < db->src_factor; i++)
+		for (i = 0; i < db->src_factor; i++) {
 			memcpy(dmabuf, dmasample, db->dma_bytes_per_sample);
+			dmabuf += interp_bytes_per_sample;
+		}
 
 		userbuf += db->user_bytes_per_sample;
-		dmabuf += interp_bytes_per_sample;
 	}
 
 	return num_samples * interp_bytes_per_sample;
@@ -1203,7 +1230,7 @@
 		while ((db->dma_qcount < 2) && (db->count >= db->fragsize)) {
 			if (au1xxx_dbdma_put_source(db->dmanr, db->nextOut,
 							db->fragsize) == 0) {
-				err("qcount < 2 and no ring room!");
+				err("qcount < 2 and no ring room!0");
 			}
 			db->nextOut += db->fragsize;
 			if (db->nextOut >= db->rawbuf + db->dmasize)
@@ -1481,6 +1508,7 @@
 					return -EINVAL;
 				stop_adc(s);
 				s->dma_adc.num_channels = val;
+				set_recv_slots(val);
 				if ((ret = prog_dmabuf_adc(s)))
 					return ret;
 			}
@@ -1538,6 +1566,7 @@
 				}
 
 				s->dma_dac.num_channels = val;
+				set_xmit_slots(val);
 				if ((ret = prog_dmabuf_dac(s)))
 					return ret;
 			}
@@ -1832,10 +1861,8 @@
 		down(&s->open_sem);
 	}
 
-	stop_dac(s);
-	stop_adc(s);
-
 	if (file->f_mode & FMODE_READ) {
+		stop_adc(s);
 		s->dma_adc.ossfragshift = s->dma_adc.ossmaxfrags =
 			s->dma_adc.subdivision = s->dma_adc.total_bytes = 0;
 		s->dma_adc.num_channels = 1;
@@ -1846,6 +1873,7 @@
 	}
 
 	if (file->f_mode & FMODE_WRITE) {
+		stop_dac(s);
 		s->dma_dac.ossfragshift = s->dma_dac.ossmaxfrags =
 			s->dma_dac.subdivision = s->dma_dac.total_bytes = 0;
 		s->dma_dac.num_channels = 1;
@@ -2091,6 +2119,9 @@
 					     ac97_read_proc, &s->codec);
 #endif
 
+	set_xmit_slots(1);
+	set_recv_slots(1);
+
 	return 0;
 
  err_dev3:
diff -Nur linux-2.4.30/drivers/sound/Config.in linux-2.4.30-linux-mips.org/drivers/sound/Config.in
--- linux-2.4.30/drivers/sound/Config.in	2005-01-19 15:10:04.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/sound/Config.in	2005-05-12 18:01:29.000000000 +0200
@@ -72,10 +72,17 @@
 if [ "$CONFIG_DDB5477" = "y" ]; then
     dep_tristate '  NEC Vrc5477 AC97 sound' CONFIG_SOUND_VRC5477 $CONFIG_SOUND
 fi
-if [ "$CONFIG_SOC_AU1X00" = "y" -o  "$CONFIG_SOC_AU1500" = "y" ]; then
-    dep_tristate '  Au1x00 Sound' CONFIG_SOUND_AU1X00 $CONFIG_SOUND
-    dep_tristate '  Au1550 PSC Sound' CONFIG_SOUND_AU1550_PSC $CONFIG_SOUND
-    dep_tristate '  Au1550 I2S Sound' CONFIG_SOUND_AU1550_I2S $CONFIG_SOUND
+if [ "$CONFIG_SOC_AU1000" = "y" -o \
+     "$CONFIG_SOC_AU1500" = "y" -o \
+     "$CONFIG_SOC_AU1100" = "y" ]; then
+    dep_tristate '  Au1x00 AC97 Sound' CONFIG_SOUND_AU1X00 $CONFIG_SOUND
+fi
+if [ "$CONFIG_SOC_AU1550" = "y" -o \
+     "$CONFIG_SOC_AU1200" = "y" ]; then
+    dep_tristate '  Au1550/Au1200 PSC AC97 Sound' CONFIG_SOUND_AU1550_PSC $CONFIG_SOUND
+    dep_tristate '  Au1550/Au1200 PSC I2S Sound' CONFIG_SOUND_AU1550_I2S $CONFIG_SOUND
+    define_tristate CONFIG_I2C y
+    define_tristate CONFIG_I2C_ALGO_AU1550 y
 fi
 
 dep_tristate '  Trident 4DWave DX/NX, SiS 7018 or ALi 5451 PCI Audio Core' CONFIG_SOUND_TRIDENT $CONFIG_SOUND $CONFIG_PCI
diff -Nur linux-2.4.30/drivers/sound/Makefile linux-2.4.30-linux-mips.org/drivers/sound/Makefile
--- linux-2.4.30/drivers/sound/Makefile	2005-01-19 15:10:04.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/sound/Makefile	2005-05-12 18:01:29.000000000 +0200
@@ -70,7 +70,7 @@
 obj-$(CONFIG_SOUND_VRC5477)	+= nec_vrc5477.o ac97_codec.o
 obj-$(CONFIG_SOUND_AU1X00)      += au1000.o ac97_codec.o  
 obj-$(CONFIG_SOUND_AU1550_PSC)  += au1550_psc.o ac97_codec.o  
-obj-$(CONFIG_SOUND_AU1550_I2S)  += au1550_i2s.o
+obj-$(CONFIG_SOUND_AU1550_I2S)  += au1550_i2s.o au1550_i2s_hw.o
 obj-$(CONFIG_SOUND_ESSSOLO1)	+= esssolo1.o
 obj-$(CONFIG_SOUND_FUSION)	+= cs46xx.o ac97_codec.o
 obj-$(CONFIG_SOUND_MAESTRO)	+= maestro.o
diff -Nur linux-2.4.30/drivers/tc/lk201.c linux-2.4.30-linux-mips.org/drivers/tc/lk201.c
--- linux-2.4.30/drivers/tc/lk201.c	2004-02-18 14:36:31.000000000 +0100
+++ linux-2.4.30-linux-mips.org/drivers/tc/lk201.c	2005-05-12 17:57:33.000000000 +0200
@@ -5,7 +5,7 @@
  * for more details.
  *
  * Copyright (C) 1999-2002 Harald Koerfgen <hkoerfg@web.de>
- * Copyright (C) 2001, 2002, 2003  Maciej W. Rozycki <macro@ds2.pg.gda.pl>
+ * Copyright (C) 2001, 2002, 2003, 2004  Maciej W. Rozycki
  */
 
 #include <linux/config.h>
@@ -23,8 +23,8 @@
 #include <asm/keyboard.h>
 #include <asm/dec/tc.h>
 #include <asm/dec/machtype.h>
+#include <asm/dec/serial.h>
 
-#include "zs.h"
 #include "lk201.h"
 
 /*
@@ -55,19 +55,20 @@
 unsigned char kbd_sysrq_key = -1;
 #endif
 
-#define KEYB_LINE	3
+#define KEYB_LINE_ZS	3
+#define KEYB_LINE_DZ	0
 
-static int __init lk201_init(struct dec_serial *);
-static void __init lk201_info(struct dec_serial *);
-static void lk201_kbd_rx_char(unsigned char, unsigned char);
+static int __init lk201_init(void *);
+static void __init lk201_info(void *);
+static void lk201_rx_char(unsigned char, unsigned char);
 
-struct zs_hook lk201_kbdhook = {
+static struct dec_serial_hook lk201_hook = {
 	.init_channel	= lk201_init,
 	.init_info	= lk201_info,
 	.rx_char	= NULL,
 	.poll_rx_char	= NULL,
 	.poll_tx_char	= NULL,
-	.cflags		= B4800 | CS8 | CSTOPB | CLOCAL
+	.cflags		= B4800 | CS8 | CSTOPB | CLOCAL,
 };
 
 /*
@@ -93,28 +94,28 @@
 	LK_CMD_ENB_BELL, LK_PARAM_VOLUME(4),
 };
 
-static struct dec_serial* lk201kbd_info;
+static void *lk201_handle;
 
-static int lk201_send(struct dec_serial *info, unsigned char ch)
+static int lk201_send(unsigned char ch)
 {
-	if (info->hook->poll_tx_char(info, ch)) {
+	if (lk201_hook.poll_tx_char(lk201_handle, ch)) {
 		printk(KERN_ERR "lk201: transmit timeout\n");
 		return -EIO;
 	}
 	return 0;
 }
 
-static inline int lk201_get_id(struct dec_serial *info)
+static inline int lk201_get_id(void)
 {
-	return lk201_send(info, LK_CMD_REQ_ID);
+	return lk201_send(LK_CMD_REQ_ID);
 }
 
-static int lk201_reset(struct dec_serial *info)
+static int lk201_reset(void)
 {
 	int i, r;
 
 	for (i = 0; i < sizeof(lk201_reset_string); i++) {
-		r = lk201_send(info, lk201_reset_string[i]);
+		r = lk201_send(lk201_reset_string[i]);
 		if (r < 0)
 			return r;
 	}
@@ -203,24 +204,26 @@
 
 static int write_kbd_rate(struct kbd_repeat *rep)
 {
-	struct dec_serial* info = lk201kbd_info;
 	int delay, rate;
 	int i;
 
 	delay = rep->delay / 5;
 	rate = rep->rate;
 	for (i = 0; i < 4; i++) {
-		if (info->hook->poll_tx_char(info, LK_CMD_RPT_RATE(i)))
+		if (lk201_hook.poll_tx_char(lk201_handle,
+					    LK_CMD_RPT_RATE(i)))
 			return 1;
-		if (info->hook->poll_tx_char(info, LK_PARAM_DELAY(delay)))
+		if (lk201_hook.poll_tx_char(lk201_handle,
+					    LK_PARAM_DELAY(delay)))
 			return 1;
-		if (info->hook->poll_tx_char(info, LK_PARAM_RATE(rate)))
+		if (lk201_hook.poll_tx_char(lk201_handle,
+					    LK_PARAM_RATE(rate)))
 			return 1;
 	}
 	return 0;
 }
 
-static int lk201kbd_rate(struct kbd_repeat *rep)
+static int lk201_kbd_rate(struct kbd_repeat *rep)
 {
 	if (rep == NULL)
 		return -EINVAL;
@@ -237,10 +240,8 @@
 	return 0;
 }
 
-static void lk201kd_mksound(unsigned int hz, unsigned int ticks)
+static void lk201_kd_mksound(unsigned int hz, unsigned int ticks)
 {
-	struct dec_serial* info = lk201kbd_info;
-
 	if (!ticks)
 		return;
 
@@ -253,20 +254,19 @@
 		ticks = 7;
 	ticks = 7 - ticks;
 
-	if (info->hook->poll_tx_char(info, LK_CMD_ENB_BELL))
+	if (lk201_hook.poll_tx_char(lk201_handle, LK_CMD_ENB_BELL))
 		return;
-	if (info->hook->poll_tx_char(info, LK_PARAM_VOLUME(ticks)))
+	if (lk201_hook.poll_tx_char(lk201_handle, LK_PARAM_VOLUME(ticks)))
 		return;
-	if (info->hook->poll_tx_char(info, LK_CMD_BELL))
+	if (lk201_hook.poll_tx_char(lk201_handle, LK_CMD_BELL))
 		return;
 }
 
 void kbd_leds(unsigned char leds)
 {
-	struct dec_serial* info = lk201kbd_info;
 	unsigned char l = 0;
 
-	if (!info)		/* FIXME */
+	if (!lk201_handle)		/* FIXME */
 		return;
 
 	/* FIXME -- Only Hold and Lock LEDs for now. --macro */
@@ -275,13 +275,13 @@
 	if (leds & LED_CAP)
 		l |= LK_LED_LOCK;
 
-	if (info->hook->poll_tx_char(info, LK_CMD_LEDS_ON))
+	if (lk201_hook.poll_tx_char(lk201_handle, LK_CMD_LEDS_ON))
 		return;
-	if (info->hook->poll_tx_char(info, LK_PARAM_LED_MASK(l)))
+	if (lk201_hook.poll_tx_char(lk201_handle, LK_PARAM_LED_MASK(l)))
 		return;
-	if (info->hook->poll_tx_char(info, LK_CMD_LEDS_OFF))
+	if (lk201_hook.poll_tx_char(lk201_handle, LK_CMD_LEDS_OFF))
 		return;
-	if (info->hook->poll_tx_char(info, LK_PARAM_LED_MASK(~l)))
+	if (lk201_hook.poll_tx_char(lk201_handle, LK_PARAM_LED_MASK(~l)))
 		return;
 }
 
@@ -307,7 +307,7 @@
 	return 0x80;
 }
 
-static void lk201_kbd_rx_char(unsigned char ch, unsigned char stat)
+static void lk201_rx_char(unsigned char ch, unsigned char fl)
 {
 	static unsigned char id[6];
 	static int id_i;
@@ -316,9 +316,8 @@
 	static int prev_scancode;
 	unsigned char c = scancodeRemap[ch];
 
-	if (stat && stat != TTY_OVERRUN) {
-		printk(KERN_ERR "lk201: keyboard receive error: 0x%02x\n",
-		       stat);
+	if (fl != TTY_NORMAL && fl != TTY_OVERRUN) {
+		printk(KERN_ERR "lk201: keyboard receive error: 0x%02x\n", fl);
 		return;
 	}
 
@@ -335,7 +334,7 @@
 			/* OK, the power-up concluded. */
 			lk201_report(id);
 			if (id[2] == LK_STAT_PWRUP_OK)
-				lk201_get_id(lk201kbd_info);
+				lk201_get_id();
 			else {
 				id_i = 0;
 				printk(KERN_ERR "lk201: keyboard power-up "
@@ -345,7 +344,7 @@
 			/* We got the ID; report it and start operation. */
 			id_i = 0;
 			lk201_id(id);
-			lk201_reset(lk201kbd_info);
+			lk201_reset();
 		}
 		return;
 	}
@@ -398,29 +397,28 @@
 	tasklet_schedule(&keyboard_tasklet);
 }
 
-static void __init lk201_info(struct dec_serial *info)
+static void __init lk201_info(void *handle)
 {
 }
 
-static int __init lk201_init(struct dec_serial *info)
+static int __init lk201_init(void *handle)
 {
 	/* First install handlers. */
-	lk201kbd_info = info;
-	kbd_rate = lk201kbd_rate;
-	kd_mksound = lk201kd_mksound;
+	lk201_handle = handle;
+	kbd_rate = lk201_kbd_rate;
+	kd_mksound = lk201_kd_mksound;
 
-	info->hook->rx_char = lk201_kbd_rx_char;
+	lk201_hook.rx_char = lk201_rx_char;
 
 	/* Then just issue a reset -- the handlers will do the rest. */
-	lk201_send(info, LK_CMD_POWER_UP);
+	lk201_send(LK_CMD_POWER_UP);
 
 	return 0;
 }
 
 void __init kbd_init_hw(void)
 {
-	extern int register_zs_hook(unsigned int, struct zs_hook *);
-	extern int unregister_zs_hook(unsigned int);
+	int keyb_line;
 
 	/* Maxine uses LK501 at the Access.Bus. */
 	if (!LK_IFACE)
@@ -428,19 +426,15 @@
 
 	printk(KERN_INFO "lk201: DECstation LK keyboard driver v0.05.\n");
 
-	if (LK_IFACE_ZS) {
-		/*
-		 * kbd_init_hw() is being called before
-		 * rs_init() so just register the kbd hook
-		 * and let zs_init do the rest :-)
-		 */
-		if(!register_zs_hook(KEYB_LINE, &lk201_kbdhook))
-			unregister_zs_hook(KEYB_LINE);
-	} else {
-		/*
-		 * TODO: modify dz.c to allow similar hooks
-		 * for LK201 handling on DS2100, DS3100, and DS5000/200
-		 */
-		printk(KERN_ERR "lk201: support for DZ11 not yet ready.\n");
-	}
+	/*
+	 * kbd_init_hw() is being called before
+	 * rs_init() so just register the kbd hook
+	 * and let zs_init do the rest :-)
+	 */
+	if (LK_IFACE_ZS)
+		keyb_line = KEYB_LINE_ZS;
+	else
+		keyb_line = KEYB_LINE_DZ;
+	if (!register_dec_serial_hook(keyb_line, &lk201_hook))
+		unregister_dec_serial_hook(keyb_line);
 }
